# Prevent stripping
%global __spec_install_post /usr/lib/rpm/brp-compress
# Turn off debuginfo package
%global debug_package %{nil}

%ifarch %ix86
%global build_dir build32
%endif
%ifarch x86_64
%global build_dir build64
%endif

Name:		pcmemtest
Version:	1.4
Release:	%mkrel 1
License:	GPLv2
Summary:	Stand-alone memory tester for x86 and x86-64 computers
Source0:	https://github.com/martinwhitaker/pcmemtest/archive/v%{version}/%{name}-%{version}.tar.gz
Source1:	20_pcmemtest
URL:		https://github.com/martinwhitaker/pcmemtest
Group:		System/Kernel and hardware
BuildRequires:	binutils
BuildRequires:	gcc
Requires(post):	drakxtools-backend
Requires(preun):drakxtools-backend
ExclusiveArch:	%{ix86} x86_64
Obsoletes:      memtest86+ < 5.31-2

%description
PCMemTest is a stand-alone memory tester for x86 and x86-64 architecture
computers. It provides a more thorough memory check than that provided by
BIOS memory tests.

PCMemTest can be loaded and run either directly by a PC BIOS (legacy or UEFI)
or via an intermediate bootloader that supports the Linux 16-bit, 32-bit,
64-bit, or EFI handover boot protocol. It should work on any Pentium class or
later 32-bit or 64-bit CPU.

%prep
%setup -q
%autopatch -p1

%build
cd %{build_dir}
# Regular build flags are not wanted for this binary
make

%install
mkdir -p %{buildroot}/boot
mkdir -p %{buildroot}/%{_sysconfdir}/grub.d

install -m644 %{build_dir}/memtest.efi -D %{buildroot}/boot/pcmemtest
install -D -m 755 %{SOURCE1} %{buildroot}/%{_sysconfdir}/grub.d/

%post
if [ -x /usr/sbin/bootloader-config ]; then
    /usr/sbin/bootloader-config --action add-entry --label PCMemTest --image /boot/pcmemtest || :
fi
if [ -d /boot/EFI/EFI ]; then
    mkdir -p /boot/EFI/EFI/memtest
    cp /boot/pcmemtest /boot/EFI/EFI/memtest/bootx64.efi
fi

%preun
if [ -x /usr/sbin/bootloader-config ]; then
    /usr/sbin/bootloader-config --action remove-entry --label PCMemTest || :
fi
if [ -f /boot/pcmemtest -a -f /boot/EFI/EFI/memtest/bootx64.efi ]; then
    if cmp -s /boot/pcmemtest /boot/EFI/EFI/memtest/bootx64.efi; then
	rm /boot/EFI/EFI/memtest/bootx64.efi
    fi
fi

%postun
# update-grub2 automatically generates menu entries, so we need to run it
# after the image has been deleted.
if [ -x /usr/sbin/detectloader -a -x /usr/bin/update-grub2 ]; then
    loader=$(/usr/sbin/detectloader)
    if [ x$loader = xGRUB2 ]; then
        /usr/bin/update-grub2 || :
    fi
fi

%files
%doc README.md
/boot/pcmemtest
%{_sysconfdir}/grub.d/20_pcmemtest


%changelog
* Sat Dec 12 2020 martinw <martinw> 1.4-1.mga8
+ Revision: 1655811
- new version 1.4

* Thu Nov 05 2020 martinw <martinw> 1.3-1.mga8
+ Revision: 1642979
- new version 1.3
- obsoletes memtest86+ (mga#25232)

* Thu Jul 09 2020 martinw <martinw> 1.2-1.mga8
+ Revision: 1603721
- update to v1.2
  o adds support for direct UEFI boot
  o adds support for 24bpp frame buffers
- installs in ESP for automatic detection by rEFInd

* Sat May 30 2020 martinw <martinw> 1.1-2.mga8
+ Revision: 1589040
- update displayed version number

* Sat May 30 2020 martinw <martinw> 1.1-1.mga8
+ Revision: 1589029
- update to v1.1

* Fri May 29 2020 martinw <martinw> 1.0-2.mga8
+ Revision: 1588921
- use linux32 command in GRUB2 menu

* Mon May 25 2020 martinw <martinw> 1.0-1.mga8
+ Revision: 1587645
- first release
- Created package structure for pcmemtest.

